import numpy

class Cubo:
	def __init__( self, p3, p5 ) :
		self.vc = numpy.zeros( 3 )
		self.R = numpy.eye( 3 )
		self.K = numpy.zeros( (3,3) )
		self.K[0][0] = 1000.0;
		self.K[1][1] = 1000.0;
		self.K[0][2] = -300.0;
		self.K[1][2] = -200.0;
		self.K[2][2] =   -1.0;

		self.v3D = numpy.zeros( (3,8) )
		self.v2D = numpy.zeros( (2,8) )
		self.v3D[0][0] = p5[0]
		self.v3D[1][0] = p5[1]
		self.v3D[2][0] = p3[2] 

		self.v3D[0][1] = p3[0]
		self.v3D[1][1] = p5[1]
		self.v3D[2][1] = p3[2] 
		# vertice 3:
		self.v3D[0][2] = p3[0]
		self.v3D[1][2] = p3[1]
		self.v3D[2][2] = p3[2] 
		# vertice 4:
		self.v3D[0][3] = p5[0]
		self.v3D[1][3] = p3[1]
		self.v3D[2][3] = p3[2] 
		# vertice 5:
		self.v3D[0][4] = p5[0]
		self.v3D[1][4] = p5[1]
		self.v3D[2][4] = p5[2] 
		# vertice 6:
		self.v3D[0][5] = p3[0]
		self.v3D[1][5] = p5[1]
		self.v3D[2][5] = p5[2] 
		# vertice 7:
		self.v3D[0][6] = p3[0]
		self.v3D[1][6] = p3[1]
		self.v3D[2][6] = p5[2] 
		# vertice 8:
		self.v3D[0][7] = p5[0]
		self.v3D[1][7] = p3[1]
		self.v3D[2][7] = p5[2] 

	def dibuja( self ) :
		# cara 5 6 7 8
		print self.v2D[0][4], self.v2D[1][4]
		print self.v2D[0][5], self.v2D[1][5]
		print self.v2D[0][6], self.v2D[1][6]
		print self.v2D[0][7], self.v2D[1][7]
		print self.v2D[0][4], self.v2D[1][4]
		print
		# cara 1 4 3 2
		print self.v2D[0][0], self.v2D[1][0]
		print self.v2D[0][3], self.v2D[1][3]
		print self.v2D[0][2], self.v2D[1][2]
		print self.v2D[0][1], self.v2D[1][1]
		print self.v2D[0][0], self.v2D[1][0]
		print
		# linea 4 8
		print self.v2D[0][3], self.v2D[1][3]
		print self.v2D[0][7], self.v2D[1][7]
		print
		# linea 1 5
		print self.v2D[0][0], self.v2D[1][0]
		print self.v2D[0][4], self.v2D[1][4]
		print
		# linea 2 6
		print self.v2D[0][1], self.v2D[1][1]
		print self.v2D[0][5], self.v2D[1][5]
		print
		# linea 3 7
		print self.v2D[0][2], self.v2D[1][2]
		print self.v2D[0][6], self.v2D[1][6]
		print

	def proyecta( self ) :	
		P1 = numpy.zeros( 3 )
		P2 = numpy.zeros( 3 )

		# l p = K R [ I | -c ] P 
		# P1 = P - c  # se translada
		# P2 = R P1   # se rota
		# l P3 = K P2 # se proyecta

		# self.vc[0] =  5.0
		# self.vc[1] =  5.0
		# self.vc[2] = 80.0
		i = 0
		while i < 8 :
			P1[0] = self.v3D[0][i] - self.vc[0]
			P1[1] = self.v3D[1][i] - self.vc[1]
			P1[2] = self.v3D[2][i] - self.vc[2]

			P2[0] = self.R[0][0]*P1[0] + self.R[0][1]*P1[1] + self.R[0][2]*P1[2]
			P2[1] = self.R[1][0]*P1[0] + self.R[1][1]*P1[1] + self.R[1][2]*P1[2]
			P2[2] = self.R[2][0]*P1[0] + self.R[2][1]*P1[1] + self.R[2][2]*P1[2]

			P1[0] = self.K[0][0] * P2[0] + self.K[0][2] * P2[2]	
			P1[1] = self.K[1][1] * P2[1] + self.K[1][2] * P2[2]	
			P1[2] = -P2[2]

			self.v2D[0][i] = P1[0] / P1[2]
			self.v2D[1][i] = P1[1] / P1[2]
			i += 1
	
	def calculaR( self, vc, vo, va ) :	
		vz = numpy.zeros( 3 )
		vz[0] = vc[0] - vo[0]
		vz[1] = vc[1] - vo[1]
		vz[2] = vc[2] - vo[2]

		self.vc = vc
		# print self.vc
		vz = vz / numpy.linalg.norm( vz )

		vx = numpy.cross( va, vz )
		vx = vx / numpy.linalg.norm( vx )

		vy = numpy.cross( vz, vx )

		self.R[0][0] = vx[0]
		self.R[0][1] = vx[1]
		self.R[0][2] = vx[2]

		self.R[1][0] = vy[0]
		self.R[1][1] = vy[1]
		self.R[1][2] = vy[2]

		self.R[2][0] = vz[0]
		self.R[2][1] = vz[1]
		self.R[2][2] = vz[2]
